"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@angular/core");
const accordion_component_1 = require("./accordion.component");
/*
 * ### Accordion heading

 Instead of using `heading` attribute on the `accordion-group`, you can use an `accordion-heading`
 attribute on `any` element inside of a group that will be used as group's header template.

 * */
let AccordionPanelComponent = class AccordionPanelComponent {
    constructor(accordion) {
        this.accordion = accordion;
    }
    // Questionable, maybe .panel-open should be on child div.panel element?
    /** Is accordion group open or closed */
    get isOpen() {
        return this._isOpen;
    }
    set isOpen(value) {
        this._isOpen = value;
        if (value) {
            this.accordion.closeOtherPanels(this);
        }
    }
    ngOnInit() {
        this.panelClass = this.panelClass || 'panel-default';
        this.accordion.addGroup(this);
    }
    ngOnDestroy() {
        this.accordion.removeGroup(this);
    }
    toggleOpen(event) {
        if (!this.isDisabled) {
            this.isOpen = !this.isOpen;
        }
    }
};
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], AccordionPanelComponent.prototype, "heading", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], AccordionPanelComponent.prototype, "panelClass", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], AccordionPanelComponent.prototype, "isDisabled", void 0);
__decorate([
    core_1.HostBinding('class.panel-open'),
    core_1.Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], AccordionPanelComponent.prototype, "isOpen", null);
AccordionPanelComponent = __decorate([
    core_1.Component({
        selector: 'menu-accordion-group',
        styleUrls: ['./accordion-group.component.css'],
        template: `
<div class="panel card" [ngClass]="panelClass">
  <div class="panel-heading card-header" role="tab" (click)="toggleOpen($event)">
    <div class="panel-title card-title">
      <div role="button" class="accordion-toggle" [attr.aria-expanded]="isOpen">
        <div *ngIf="heading"[ngClass]="{'text-muted': isDisabled}">{{heading}}</div>
        <ng-content select="[accordion-heading]"></ng-content>
      </div>
    </div>
  </div>
  <div class="panel-collapse collapse" role="tabpanel" [collapse]="!isOpen">
    <div class="panel-body card-block">
      <ng-content></ng-content>
    </div>
  </div>
</div>
  `
    }),
    __param(0, core_1.Inject(accordion_component_1.AccordionComponent)),
    __metadata("design:paramtypes", [accordion_component_1.AccordionComponent])
], AccordionPanelComponent);
exports.AccordionPanelComponent = AccordionPanelComponent;
//# sourceMappingURL=accordion-group.component.js.map