"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@angular/core");
/** Displays collapsible content panels for presenting information in a limited amount of space. */
let AccordionComponent = class AccordionComponent {
    /** Displays collapsible content panels for presenting information in a limited amount of space. */
    constructor() {
        this.groups = [];
    }
    // public constructor(config: AccordionConfig) {
    //   Object.assign(this, config);
    // }
    closeOtherPanels(openGroup) {
        if (!this.closeOthers) {
            return;
        }
        this.groups.forEach((group) => {
            if (group !== openGroup) {
                group.isOpen = false;
            }
        });
    }
    addGroup(group) {
        this.groups.push(group);
    }
    removeGroup(group) {
        let index = this.groups.indexOf(group);
        if (index !== -1) {
            this.groups.splice(index, 1);
        }
    }
    get closeAll() {
        return this._closeAll;
    }
    set closeAll(value) {
        this._closeAll = value;
        if (value) {
            this.closeAllHeader();
        }
    }
    closeAllHeader() {
        this.groups.forEach((group) => {
            group.isOpen = false;
        });
    }
};
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], AccordionComponent.prototype, "closeOthers", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], AccordionComponent.prototype, "closeAll", null);
AccordionComponent = __decorate([
    core_1.Component({
        selector: 'menu-accordion',
        template: `<ng-content></ng-content>`,
        // tslint:disable-next-line
        host: {
            '[class.panel-group]': 'true',
            '[attr.aria-multiselectable]': 'closeOthers',
            role: 'tablist'
        }
    })
], AccordionComponent);
exports.AccordionComponent = AccordionComponent;
//# sourceMappingURL=accordion.component.js.map