"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
// todo: add animations when https://github.com/angular/angular/issues/9947 solved
const core_1 = require("@angular/core");
let CollapseDirective = class CollapseDirective {
    constructor(_el, _renderer) {
        /** This event fires as soon as content collapses */
        this.collapsed = new core_1.EventEmitter();
        /** This event fires as soon as content becomes visible */
        this.expanded = new core_1.EventEmitter();
        // shown
        this.isExpanded = true;
        // hidden
        this.isCollapsed = false;
        // stale state
        this.isCollapse = true;
        // animation state
        this.isCollapsing = false;
        this._el = _el;
        this._renderer = _renderer;
    }
    /** A flag indicating visibility of content (shown or hidden) */
    set collapse(value) {
        this.isExpanded = value;
        this.toggle();
    }
    get collapse() {
        return this.isExpanded;
    }
    /** allows to manually toggle content visibility */
    toggle() {
        if (this.isExpanded) {
            this.hide();
        }
        else {
            this.show();
        }
    }
    /** allows to manually hide content */
    hide() {
        this.isCollapse = false;
        this.isCollapsing = true;
        this.isExpanded = false;
        this.isCollapsed = true;
        this.isCollapse = true;
        this.isCollapsing = false;
        this.display = 'none';
        this.collapsed.emit(this);
    }
    /** allows to manually show collapsed content */
    show() {
        this.isCollapse = false;
        this.isCollapsing = true;
        this.isExpanded = true;
        this.isCollapsed = false;
        this.display = 'block';
        // this.height = 'auto';
        this.isCollapse = true;
        this.isCollapsing = false;
        this._renderer.setElementStyle(this._el.nativeElement, 'overflow', 'visible');
        this._renderer.setElementStyle(this._el.nativeElement, 'height', 'auto');
        this.expanded.emit(this);
    }
};
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], CollapseDirective.prototype, "collapsed", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], CollapseDirective.prototype, "expanded", void 0);
__decorate([
    core_1.HostBinding('style.display'),
    __metadata("design:type", String)
], CollapseDirective.prototype, "display", void 0);
__decorate([
    core_1.HostBinding('class.in'),
    core_1.HostBinding('class.show'),
    core_1.HostBinding('attr.aria-expanded'),
    __metadata("design:type", Object)
], CollapseDirective.prototype, "isExpanded", void 0);
__decorate([
    core_1.HostBinding('attr.aria-hidden'),
    __metadata("design:type", Object)
], CollapseDirective.prototype, "isCollapsed", void 0);
__decorate([
    core_1.HostBinding('class.collapse'),
    __metadata("design:type", Object)
], CollapseDirective.prototype, "isCollapse", void 0);
__decorate([
    core_1.HostBinding('class.collapsing'),
    __metadata("design:type", Object)
], CollapseDirective.prototype, "isCollapsing", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], CollapseDirective.prototype, "collapse", null);
CollapseDirective = __decorate([
    core_1.Directive({
        selector: '[menuCollapse]',
        exportAs: 'bs-collapse',
        /* tslint:disable-next-line */
        host: { '[class.collapse]': 'true' }
    }),
    __metadata("design:paramtypes", [core_1.ElementRef, core_1.Renderer])
], CollapseDirective);
exports.CollapseDirective = CollapseDirective;
//# sourceMappingURL=collapse.directive.js.map