"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@angular/core");
const menu_service_1 = require("../sharedservice/menu.service");
const menu_source_item_1 = require("../model/menu-source-item");
let SidenavComponent = class SidenavComponent {
    constructor(menuService, elRef) {
        this.menuService = menuService;
        this.elRef = elRef;
        this.isFirstOpen = false;
        this.closeAll = false;
        this.closeAllSubmenuItems = false;
        this.menuItems = [];
    }
    onMouseenter() {
        this.isMousedown = true;
        this.isFirstOpen = false;
        this.closeAll = false;
        this.closeAllSubmenuItems = false;
    }
    onMouseup() {
        this.isMousedown = true;
        this.isFirstOpen = false;
    }
    onMouseleave() {
        this.isMousedown = false;
        this.isFirstOpen = false;
        this.closeAll = true;
        this.closeAllSubmenuItems = true;
    }
    ngOnInit() {
        this.getMenuItems();
    }
    getMenuItems() {
        this.menuService.getMenuItems()
            .subscribe(menuItems => {
            let response = menuItems;
            let menuMap = new Map();
            response.Data.forEach(item => {
                if (item.MenuItemId === item.ParentMenuItemId) {
                    if (!menuMap.get(item.ParentMenuItemId)) {
                        this.menuItems.push(this.getMenuSourceItem(item));
                    }
                }
                else {
                    let itemFound = false;
                    for (let i = 0; i < this.menuItems.length; i++) {
                        if (this.menuItems[i].MenuItemId === item.ParentMenuItemId) {
                            itemFound = true;
                            this.menuItems[i].Children.push(this.getMenuSourceItem(item));
                            break;
                        }
                        if (!itemFound) {
                            let children = this.menuItems[i].Children;
                            for (let j = 0; j < children.length; j++) {
                                if (children[j].MenuItemId === item.ParentMenuItemId) {
                                    let subChild = children[j];
                                    subChild.Children.push(this.getMenuSourceItem(item));
                                    itemFound = true;
                                    break;
                                }
                            }
                        }
                        if (itemFound) {
                            break;
                        }
                    }
                }
            });
        });
    }
    getMenuSourceItem(item) {
        let menuSourceItem = new menu_source_item_1.MenuSourceItem();
        // for (let prop in item) {
        // menuSourceItem[prop] = item[prop];
        // }
        return menuSourceItem;
    }
    onMenuItemClick(event, item) {
        event.stopImmediatePropagation();
        this.closeAllSubmenuItems = true;
        if (item.Link != null && item.Target == null || item.Link != null && item.Target === '_blank') {
            window.location.href = item.Link;
        }
    }
};
SidenavComponent = __decorate([
    core_1.Component({
        selector: 'menu-sidenav',
        templateUrl: './sidenav.component.html',
        styleUrls: ['./sidenav.component.css']
    }),
    __metadata("design:paramtypes", [menu_service_1.MenuService, core_1.ElementRef])
], SidenavComponent);
exports.SidenavComponent = SidenavComponent;
//# sourceMappingURL=sidenav.component.js.map